<template>
	<div class="system-user-container">
		<el-card shadow="hover">
			<div class="system-user-search mb15">
				<el-form :inline="true" class="demo-form-inline">
					<el-form-item>
						<el-input size="default" v-model="listQuery.searchParams.name" placeholder="预案名称" style="max-width: 215px"> </el-input>
					</el-form-item>
					<el-form-item>
						<el-select size="default" v-model="listQuery.searchParams.type" placeholder="请选择预案类型" class="ml10" style="max-width: 215px">
							<el-option label="综合应急预案" value="1"></el-option>
							<el-option label="现场处置方案" value="2"></el-option>
							<el-option label="专项应急预案" value="3"></el-option>
							<el-option label="其他预案" value="4"></el-option>
						</el-select>
					</el-form-item>
					<el-form-item>
						<el-button size="default" type="primary" class="ml10" @click="onSubmit"> 查询 </el-button>
						<el-button size="default" class="ml10" @click="submitReset"> 重置 </el-button>
					</el-form-item>
				</el-form>
			</div>
			<div class="button_Line">
				<div class="button_Left">
					<el-button size="default" type="primary" @click="onOpenAdd">
						<el-icon>
							<Plus /> </el-icon
						>新建
					</el-button>
					<el-button size="default" type="warning" plain :disabled="warning">
						<el-icon>
							<Edit /> </el-icon
						>修改
					</el-button>
					<el-button size="default" type="danger" plain :disabled="danger" @click="onDeleteAll">
						<el-icon>
							<Delete /> </el-icon
						>删除
					</el-button>
					<el-button size="default" type="primary" @click="onabolishLibrary"> 废止库 </el-button>
				</div>
				<div class="button_Right">
					<!--          <el-button size="default" @click="upButton">-->
					<!--            <el-icon>-->
					<!--              <Upload />-->
					<!--            </el-icon>-->
					<!--          </el-button>-->
					<!--          <el-button size="default">-->
					<!--            <el-icon>-->
					<!--              <Download />-->
					<!--            </el-icon>-->
					<!--          </el-button>-->
					<!--          <el-button size="default">-->
					<!--            <el-icon>-->
					<!--              <Refresh />-->
					<!--            </el-icon>-->
					<!--          </el-button>-->
				</div>
			</div>
			<el-table :data="tableData" style="width: 100%" ref="multipleTableRef" @selection-change="handleSelectionChange">
				<el-table-column type="selection" width="55" />
				<el-table-column prop="name" label="预案名称" show-overflow-tooltip sortable></el-table-column>
				<el-table-column prop="type" label="预案类型" show-overflow-tooltip sortable>
          <template #default="scope">
            <span v-if="scope.row.type == 1">综合应急预案</span>
            <span v-if="scope.row.type == 2">现场处置方案</span>
            <span v-if="scope.row.type == 3">专项应急预案</span>
            <span v-if="scope.row.type == 4">其他预案</span>
          </template>
        </el-table-column>
				<el-table-column prop="level" label="预案级别" show-overflow-tooltip sortable>
          <template #default="scope">
            <span v-if="scope.row.level == 1">综合应急预案</span>
            <span v-if="scope.row.level == 2">现场处置方案</span>
            <span v-if="scope.row.level == 3">专项应急预案</span>
          </template>
        </el-table-column>
				<el-table-column prop="releaseDate" label="发布实施日期" show-overflow-tooltip sortable></el-table-column>
				<el-table-column label="操作" width="260" align="center" fixed="right">
					<template #default="scope">
						<el-button size="small" text type="primary" @click="isDialogFormVisible(scope.row.id)">
							<el-icon style="margin-right: 5px">
								<VideoPlay /> </el-icon
							>启动
						</el-button>
						<el-button size="small" text type="primary" @click="abolish(scope.row.id)">
							<el-icon style="margin-right: 5px">
								<VideoPause /> </el-icon
							>废止
						</el-button>
						<el-button size="small" text type="primary" @click="onEdit('修改', scope.row.id)">
							<el-icon style="margin-right: 5px">
								<EditPen /> </el-icon
							>修改
						</el-button>
						<el-button
							size="small"
							text
							type="primary"
							v-if="scope.row.approveStatus === 0 || scope.row.approveStatus === null"
							@click="initiateApproval(scope.row.id)"
						>
							发起审批
						</el-button>
						<el-button
							size="small"
							text
							type="primary"
							v-if="scope.row.approveStatus === 2 && scope.row.checkApprove === true"
							@click="onApproval('修改',scope.row.approveId,scope.row.id)"
						>
							审批
						</el-button>
						<el-button
							size="small"
							text
							type="primary"
							v-if="scope.row.approveStatus === 2 && scope.row.checkApprove === false"
							@click="onApproval('详情',scope.row.approveId,scope.row.id)"
						>
              查看审批
						</el-button>
						<el-button size="small" text type="primary" v-if="scope.row.approveStatus === 3" @click="onApprovalProcess(scope.row.id)">
							查看审批流程
						</el-button>
						<!--            <el-button size="small" text type="primary" @click="jumpFrom(0)">-->
						<!--              <el-icon style="margin-right: 5px;">-->
						<!--                <EditPen />-->
						<!--              </el-icon>修改-->
						<!--            </el-button>-->
						<!--            <el-button  size="small" text type="primary" @click="abolish(0)">-->
						<!--             发起审批-->
						<!--            </el-button>-->
						<el-button size="small" text type="primary" @click="onRowDel(scope.row.id)">
							<el-icon>
								<Delete /> </el-icon
							>删除
						</el-button>
					</template>
				</el-table-column>
			</el-table>
			<div class="pages">
				<el-pagination
					v-if="tableData.length == 0 ? false : true"
					v-model:currentPage="pageIndex"
					v-model:page-size="pageSize"
					:page-sizes="[10, 20, 30]"
					:pager-count="5"
					class="mt15"
					background
					layout="total, sizes, prev, pager, next, jumper"
					:total="total"
					@size-change="onHandleSizeChange"
					@current-change="onHandleCurrentChange"
				/>
			</div>
		</el-card>
		<OpenAdd ref="addRef" @myAdd="onMyAdd" />
		<AbolishLibrary ref="abolishRef" @myAdd="onMyAdd" />
		<InitiateApproval ref="initiateApprovalRef" @myAdd="onMyAdd" />
		<Approval ref="approvalRef" @myAdd="onMyAdd" />
    <ApprovalProcess ref="processRef" @myAdd="onMyAdd" />
		<!--    <StartUp ref="startRef" @myAdd="startUp"/>-->
		<el-dialog v-model="dialogFormVisible" width="30%" title="启动" :fullscreen="full">
			<el-button @click="toggleFullscreen" size="small" class="pot" :icon="FullScreen"></el-button>
			<el-form :model="form" ref="ruleFormRef" label-width="80px">
				<el-form-item label="备注">
					<el-input v-model="form.remark" type="textarea" autocomplete="off" />
				</el-form-item>
			</el-form>
			<template #footer>
				<span class="dialog-footer">
					<el-button @click="dialogFormVisible = false">取消</el-button>
					<el-button type="primary" @click="onDetermine">确定</el-button>
				</span>
			</template>
		</el-dialog>
	</div>
</template>

<script lang="ts">
import { reactive, onMounted, ref, defineComponent } from 'vue';
import { ElMessageBox, ElMessage } from 'element-plus';
// import {useRouter} from "vue-router"
import type {} from // FormInstance,
'element-plus';
import { Plus, Edit, Delete, Upload, Download, Refresh, VideoPause, VideoPlay, EditPen, FullScreen } from '@element-plus/icons-vue';
import OpenAdd from '/@/views/contingencyManagement/panManagement/component/openAdd.vue';
// import StartUp from '/@/views/contingencyManagement/panManagement/component/startUp.vue';
import AbolishLibrary from '/@/views/contingencyManagement/panManagement/component/abolishLibrary.vue';
import ApprovalProcess from '/@/views/contingencyManagement/panManagement/component/approvalProcess.vue';
import InitiateApproval from '/@/views/contingencyManagement/panManagement/component/initiateApproval.vue';
import Approval from '/@/views/contingencyManagement/panManagement/component/approval.vue';
// import UpData from '/@/views/contingencyManagement/panManagement/component/upData.vue';
import { emergencyPlanApi } from '/@/api/contingencyManagement/emergencyPlan';
import { emergencyPlanLogApi } from '/@/api/contingencyManagement/emergencyPlanLog';

export default defineComponent({
	name: 'systemUser',
	components: {
		OpenAdd,
		// StartUp,
		InitiateApproval,
		AbolishLibrary,
		Approval,
		EditPen,
		Plus,
		Edit,
		Delete,
		Upload,
		Download,
		Refresh,
		VideoPause,
		VideoPlay,
    ApprovalProcess,
		// UpData,
		emergencyPlanApi,
	},
	setup(prop, { emit }) {
		// 列表参数
		const listQuery = reactive({
			pageIndex: 1,
			pageSize: 10,
			searchParams: {
				name: '',
				type: '',
				abolishStatus: false,
			},
		});
		// 定义表格数据
		const tableData = ref([]);
		// 列表数据请求
		const onSubmit = async () => {
			let res = await emergencyPlanApi().getEmergencyPlanList(listQuery);
			if (res.data.code === '200') {
				tableData.value = res.data.data;
				pageIndex.value = res.data.pageIndex;
				pageSize.value = res.data.pageSize;
				total.value = res.data.total;
			} else {
				ElMessage({
					showClose: true,
					type: 'error',
					message: res.data.msg,
				});
			}
		};
		// 重置
		const submitReset = () => {
			listQuery.searchParams.name = '';
			listQuery.searchParams.type = '';
			onSubmit();
		};
		const warning = ref(true);
		const danger = ref(true);

		// 上传
		// const upShow=ref()
		// const upButton=()=>{
		//   upShow.value.openDialog()
		// }
		// 启动弹窗
		const isDialogFormVisible = (data: any) => {
			dialogFormVisible.value = true;
			form.value.planId = data;
		};
		const dialogFormVisible = ref(false);
		const form = ref({
			remark: '',
		});
		const onDetermine = () => {
			dialogFormVisible.value = false;
			emergencyPlanLogApi()
				.addEmergencyPlanLog(form.value)
				.then((res) => {
					if (res.data.code == 200) {
						ElMessage({
							showClose: true,
							message: res.data.msg,
							type: 'success',
						});
						emit('myAdd', true);
					} else {
						ElMessage({
							showClose: true,
							message: res.data.msg,
							type: 'error',
						});
						emit('myAdd', true);
					}
				});
			form.value = {
				remark: '',
			};
		};
		// 打开新增用户弹窗
		const addRef = ref();
		const onOpenAdd = () => {
			addRef.value.openDialog('新建应急预案管理', false);
		};
		// 新增后刷新
		const onMyAdd = (e: boolean) => {
			if (e) {
				onSubmit();
			} else {
				onSubmit();
			}
		};
		// 打开修改应急预案管理弹窗
		const onEdit = (val: string, row: object) => {
			if (val == '详情') {
				addRef.value.openDialog('查看应急预案管理', row, true);
			} else {
				addRef.value.openDialog('修改应急预案管理', row, false);
			}
		};

		//打开废止库弹窗
		const abolishRef = ref();
		const onabolishLibrary = () => {
			abolishRef.value.openDialog();
		};
		// 废止
		const abolish = (data: any) => {
			ElMessageBox.confirm('确定要废止所选项吗?', '提示', {
				confirmButtonText: '确认',
				cancelButtonText: '取消',
				type: 'warning',
			})
				.then(() => {
					emergencyPlanApi()
						.EmergencyTeam(data)
						.then((res) => {
							if (res.data.code == 200) {
								ElMessage({
									showClose: true,
									message: res.data.msg,
									type: 'success',
								});
								onSubmit();
							} else {
								ElMessage({
									showClose: true,
									message: res.data.msg,
									type: 'error',
								});
								onSubmit();
							}
						});
				})
				.catch(() => {});
		};

		// 删除用户
		const onRowDel = (id: number) => {
			let arr = [];
			arr.push(id);
			ElMessageBox.confirm('确定删除所选项吗?', '提示', {
				confirmButtonText: '确认',
				cancelButtonText: '取消',
				type: 'warning',
			})
				.then(() => {
					emergencyPlanApi()
						.deleteEmergencyTeam(arr)
						.then((res) => {
							if (res.data.code == 200) {
								ElMessage({
									showClose: true,
									message: res.data.msg,
									type: 'success',
								});
								onSubmit();
							} else {
								ElMessage({
									showClose: true,
									message: res.data.msg,
									type: 'error',
								});
								onSubmit();
							}
						});
				})
				.catch(() => {});
		};

		const deleteAll = ref();
		const handleSelectionChange = (val: any) => {
			let valId = JSON.parse(JSON.stringify(val));
			let arr = [];
			for (let i = 0; i < valId.length; i++) {
				arr.push(valId[i].id);
			}
			deleteAll.value = arr;
			if (val.length == 1) {
				warning.value = false;
				danger.value = false;
			} else if (val.length == 0) {
				warning.value = true;
				danger.value = true;
			} else {
				warning.value = true;
				danger.value = false;
			}
		};
		// 多选删除
		const onDeleteAll = () => {
			ElMessageBox.confirm('确定删除所选项吗?', '提示', {
				confirmButtonText: '确定',
				cancelButtonText: '取消',
				type: 'warning',
			})
				.then(() => {
					emergencyPlanApi()
						.deleteEmergencyTeam(deleteAll.value)
						.then((res) => {
							if (res.data.code == 200) {
								ElMessage({
									message: res.data.msg,
									type: 'success',
								});
								onSubmit();
							} else {
								ElMessage({
									showClose: true,
									message: res.data.msg,
									type: 'error',
								});
								onSubmit();
							}
						});
				})
				.catch(() => {});
		};
		// 分页
		const pageIndex = ref();
		const pageSize = ref();
		const total = ref();
		// 分页改变
		const onHandleSizeChange = (val: number) => {
			listQuery.pageSize = val;
			onSubmit();
		};
		// 分页未改变
		const onHandleCurrentChange = (val: number) => {
			listQuery.pageIndex = val;
			onSubmit();
		};

		// const router=useRouter()
		// 修改跳转
		// const jumpFrom=(data:string)=>{
		//   router.push({
		//     path:"/processForm",
		//     query:{
		//       type:data
		//     }
		//   })
		// }
		// 发起审批跳转
		// const abolish=(data:string)=>{
		//   router.push({
		//     path:"/abolishDialog",
		//     query:{
		//       type:data
		//     }
		//   })
		// }
		// 发起审批弹窗
		const initiateApprovalRef = ref();
		const initiateApproval = (row: object) => {
			initiateApprovalRef.value.openDialog('发起审批',row, true);
		};
		// 审批
		const approvalRef = ref();
		const onApproval = (val: string,row: object,id) => {
      if(val=='详情'){
        approvalRef.value.openDialog('查看审批', row, true);
      } else {
        approvalRef.value.openDialog('审批', row, false,id);
      }
		};
    // 审批流程
    const processRef = ref();
    const onApprovalProcess = (row:object,id) => {
      processRef.value.openDialog(row,id);
    };

		//全屏
		const full = ref(false);
		const toggleFullscreen = () => {
			if (full.value == false) {
				full.value = true;
			} else {
				full.value = false;
			}
		};
		// 页面加载时
		onMounted(() => {
			onSubmit();
		});
		return {
			tableData,
			onSubmit,
			onOpenAdd, //新增
			addRef,
			onabolishLibrary,
			abolishRef,
			abolish,
			onRowDel,
			onHandleSizeChange,
			onHandleCurrentChange,
			toggleFullscreen,
			FullScreen,
			full,
			listQuery,
			pageIndex,
			pageSize,
			total,
			submitReset,
			onMounted,
			deleteAll,
			warning,
			danger,
			handleSelectionChange,
			onMyAdd,
			onDeleteAll,
			dialogFormVisible,
			isDialogFormVisible,
			form,
			emit,
			onDetermine,
			onEdit,
			initiateApproval,
			initiateApprovalRef,
			onApproval,
			approvalRef,
      onApprovalProcess,
      processRef,
		};
	},
});
</script>
<style scoped lang="scss">
.table_Box {
	padding: 20px;
	background-color: #fff;
}
.tableForm {
	margin-top: 10px;
}
/*按钮行*/
.button_Line {
	display: flex;
	flex-direction: row;
	justify-content: space-between;
	margin-bottom: 10px;
}
.el-form .el-form-item {
	margin-bottom: 0 !important;
}
.el-button--text {
	margin-right: 15px;
}
.el-select {
	width: 300px;
}
.el-input {
	width: 300px;
}
.dialog-footer button:first-child {
	margin-right: 10px;
}
//弹窗底部边框线
::v-deep .el-dialog__footer {
	border-top: 1px solid #e8e8e8;
	border-radius: 0 0 4px 4px;
}
//弹窗顶部边框线
::v-deep .el-dialog__header {
	border-bottom: 1px solid #e8e8e8;
	margin-right: 0;
	border-radius: 4px 4px 0 0;
}
//表头
::v-deep .el-table th.el-table__cell {
	background-color: #f6f7fa;
	font-weight: 400;
	color: #909399;
}
.el-table .sort-caret.ascending {
	border-bottom-color: #c0c4cc;
}
//分页
.pages {
	display: flex;
	justify-content: flex-end;
	margin-top: 15px;
}
::v-deep .el-pagination .el-pager li {
	margin: 0 5px;
	background-color: #f4f4f5;
	color: #606266;
	min-width: 30px;
	border-radius: 2px;
}
::v-deep .el-pagination .el-pager li.is-active {
	background-color: #409eff;
	color: #fff;
}
::v-deep .el-pagination .btn-prev {
	margin: 0 5px;
	background-color: #f4f4f5;
	color: #606266;
	min-width: 30px;
	border-radius: 2px;
}
::v-deep .el-pagination button:disabled {
	color: #c0c4cc;
}
::v-deep .el-pagination .btn-next {
	margin: 0 5px;
	background-color: #f4f4f5;
	color: #606266;
	min-width: 30px;
	border-radius: 2px;
}
</style>